local HPHeight=1.0
local TrinketFont=24
ChildrenFrames=9
MainFrameChildren=1
local TFScale=0.8
local TFMax=16
local DecayTime=30
local DRFont=22
local cursorscale=4
local DB1=false-- For debugging frame removal / additions
local DB2=false --For debugging creating combat versus non combat frames
local DB3=false --For debugging adding buttons to click frames
local DB4=false --For seeing how long each function executes
local Red={255/255, 122/255, 122/255}
local Green={122/255, 255/255, 122/255}
local SpacerSize=0.33

local OrbIDs={
	[121164] = "Interface\\MiniMap\\TempleofKotmogu_ball_cyan",
	[121175] = "Interface\\MiniMap\\TempleofKotmogu_ball_purple",
	[121176] = "Interface\\MiniMap\\TempleofKotmogu_ball_green",  
	[121177] = "Interface\\MiniMap\\TempleofKotmogu_ball_orange",
	}
local FlagIDs={
	[46392] = "Focused Assault",
	[46393] = "Brutal Assault"
	}
	
--SetClassFrame
--InsertFrame
--SortFrames
--These are lagging
function MainFrameCreate()
	mainframe=CreateFrame("Button", "mainframe", UIParent)
	mainframe:SetWidth(XSize)
	mainframe:SetHeight(YSize)
	mainframe:ClearAllPoints()
	mainframe:SetPoint("TOP",UIParent)
	mainframe:Show()
	mainframe:EnableMouse(true)
	mainframe:SetMovable(true)
	mainframe:RegisterForDrag("LeftButton")
	mainframe:SetScript("OnDragStart", mainframe.StartMoving)
	mainframe:SetScript("OnDragStop", mainframe.StopMovingOrSizing)
	mainframe:SetScript("OnClick", function () 
		InterfaceOptionsFrame_OpenToCategory(panel.name);
		InterfaceOptionsFrame_OpenToCategory(panel.name);
	end)
	
	mainframe.bg = mainframe:CreateTexture("ARTWORK");
	mainframe.bg:SetAllPoints();
	mainframe.bg:SetTexture(0, 0, 0); 
	mainframe.bg:SetAlpha(0);
	
	mainframe.text=mainframe:CreateFontString(nil, "OVERLAY")
	mainframe.text:SetPoint("CENTER", mainframe, "CENTER")
	mainframe.text:SetAllPoints()
	mainframe.text:SetFont("Fonts\\FRIZQT__.TTF", FontSize, "OUTLINE")
	mainframe.text:SetJustifyH("CENTER")
	mainframe.text:SetText("PredatorFrames Display Backdrop \n \n Click this grey rectangle to open the configuration panel, also under Interface/Addons in your game menu.  You should hide this grey rectangle after moving it to a location of your liking by unchecking the checkbox "..
		"labeled Show / Hide Frame Area.")
	
	--[[
	button=CreateFrame("Button", "testbutton", mainframe, "SecureActionButtonTemplate")
	button:SetPoint("TOPLEFT", 50, 50)
	button:SetHeight(20)
	button:SetWidth(50)
	button:Show()
	button:SetText("Test")
        button:SetNormalTexture("Interface/Buttons/UI-Panel-Button-Up")
        button:SetHighlightTexture("Interface/Buttons/UI-Panel-Button-Highlight")
        button:SetPushedTexture("Interface/Buttons/UI-Panel-Button-Down")
	button:SetAttribute("type", "target")
	button:SetAttribute("unit", targetname)
	--]]
	--[[
	TargetFrame=CreateFrame("Frame", nil, mainframe)
	TargetFrame:Show()
	TargetFrame:SetPoint("TOP", mainframe, "TOP")
	TargetFrame:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
					tile = false, tileSize = 16, edgeSize = 16, 
					insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	--]]				
	--TargetFrame:SetWidth(XSize)
	--TargetFrame:SetHeight(YSize)
end

function TargetFrameCreate()
	print("called TargetFrameCreate", XSize, FSize)
	PlayerTargetFrame=CreateFrame("Frame", "PlayerTargetFrame", UIParent)
	PlayerTargetFrame:Show()
	--PlayerTargetFrame:SetPoint("TOP", UIParent, "TOP")
	PlayerTargetFrame:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
					tile = false, tileSize = 16, edgeSize = 16, 
					insets = { left = 4, right = 4, top = 4, bottom = 4 }})	
	PlayerTargetFrame:SetWidth(XSize+cursorscale)
	PlayerTargetFrame:SetHeight(FrameHeight+cursorscale)
	PlayerTargetFrame:SetFrameLevel(100)
end

function CreateTargetFrame(name, count, role, party, id)
	--debugprofilestart()
	if name~="" then
		if _G["PlayerFrame" .. name .. "Health"] then
			if _G["PlayerFrame" .. name .. "Target" .. count] then --A frame already exists, just show it.
				_G["PlayerFrame" .. name .. "Target" .. count]:SetParent(_G["PlayerFrame" .. name .. "Health"])
				_G["PlayerFrame" .. name .. "Target" .. count]:Show()
			else
				_G["PlayerFrame" .. name .. "Target" .. count] = CreateFrame("Frame", nil, _G["PlayerFrame" .. name .. "Health"])
				_G["PlayerFrame" .. name .. "Target" .. count].texture = _G["PlayerFrame" .. name .. "Target" .. count]:CreateTexture(nil, "BACKGROUND")
			end
			if TargetPortraitLocation==1 then 
				_G["PlayerFrame" .. name .. "Target" .. count]:SetPoint("LEFT", _G["PlayerFrame" .. name .. "Health"], "LEFT", count*CurrentFrameHeight, 0)
			else
				if TrinketWork then
					_G["PlayerFrame" .. name .. "Target" .. count]:SetPoint("LEFT", _G["PlayerFrame" .. name .. "Health"], "RIGHT", (count+1)*CurrentFrameHeight, 0)
				else
					_G["PlayerFrame" .. name .. "Target" .. count]:SetPoint("LEFT", _G["PlayerFrame" .. name .. "Health"], "RIGHT", count*CurrentFrameHeight, 0)
				end
			end
			_G["PlayerFrame" .. name .. "Target" .. count]:SetHeight(CurrentFrameHeight)
			_G["PlayerFrame" .. name .. "Target" .. count]:SetWidth(CurrentFrameHeight)
			_G["PlayerFrame" .. name .. "Target" .. count].texture:SetHeight(CurrentFrameHeight)
			_G["PlayerFrame" .. name .. "Target" .. count].texture:SetWidth(CurrentFrameHeight)
			_G["PlayerFrame" .. name .. "Target" .. count].texture:SetPoint("CENTER", _G["PlayerFrame" .. name .. "Target" .. count], "CENTER")
			if role=="Flag Carrier" then
				if ThePlayersFaction=="Alliance" then
					_G["PlayerFrame" .. name .. "Target" .. count]:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/AllianceFlag",  tile = false})
				else
					_G["PlayerFrame" .. name .. "Target" .. count]:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/HordeFlag",  tile = false})
				end
				_G["PlayerFrame" .. name .. "Target" .. count].texture:Hide()
				if TargetPortraitLocation==1 then _G["PlayerFrame" .. name .. "Health"].name:SetPoint("LEFT", _G["PlayerFrame" .. name .. "Health"], "LEFT", (count+1)*CurrentFrameHeight, 0) end
				for i=1, 40 do
					local aura, _, _, stack, _, _, _, _, _, _, spellId=UnitDebuff(id, i)
					if spellId==nil then break end
					if OrbIDs[spellId] then 
						_G["PlayerFrame" .. name .. "Target" .. count]:SetBackdrop({bgFile=OrbIDs[spellId],  tile = false})
						break
					elseif FlagIDs[spellId] then
						if _G["PlayerFrame" .. name .. "Target" .. count] then 
							if _G["PlayerFrame" .. name .. "Target" .. count].text then
						
							else
								_G["PlayerFrame" .. name .. "Target" .. count].text=_G["PlayerFrame" .. name .. "Target" .. count]:CreateFontString(nil, "OVERLAY")
								_G["PlayerFrame" .. name .. "Target" .. count].text:SetPoint("CENTER", _G["PlayerFrame" .. name .. "Target" .. count], "CENTER")
								_G["PlayerFrame" .. name .. "Target" .. count].text:SetJustifyH("CENTER")
							end
							local DRText
							if (0.42*CurrentFrameHeight)<DRFont then
								DRText=(math.max((0.42*CurrentFrameHeight), 1))
							else
								DRText=DRFont
							end
							_G["PlayerFrame" .. name .. "Target" .. count].text:SetFont("Fonts\\FRIZQT__.TTF", DRText, "OUTLINE")
							_G["PlayerFrame" .. name .. "Target" .. count].text:SetTextColor(1-(stack-11)/10, 1-(stack-1)/10, 1)
							local text=string.format("%.0f%%", stack*10)
							_G["PlayerFrame" .. name .. "Target" .. count].text:SetText(text)
						end
						break
					end
				end
			elseif TargetPortraitLocation~=3 then --Setting a target portrait, and it is not disabled.
				_G["PlayerFrame" .. name .. "Target" .. count].texture:Show()
				SetPortraitTexture(_G["PlayerFrame" .. name .. "Target" .. count].texture, party)
				_G["PlayerFrame" .. name .. "Target" .. count]:SetBackdrop({})
				if TargetPortraitLocation==1 then _G["PlayerFrame" .. name .. "Health"].name:SetPoint("LEFT", _G["PlayerFrame" .. name .. "Health"], "LEFT", (count+1)*CurrentFrameHeight, 0) end
			else --Frame is not for flag carrier, and target portraits are disabled
				_G["PlayerFrame" .. name .. "Target" .. count].texture:Hide()
				_G["PlayerFrame" .. name .. "Target" .. count]:SetBackdrop({})
			end
		end
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute CreateTargetFrame")
	--end
end

function RemoveTargetFrames()
	--debugprofilestart()
	local frame=mainframe
	if frame:GetNumChildren()>MainFrameChildren then --There are player frames in existance
		frame=select(MainFrameChildren+1, frame:GetChildren()) --frame is now the first player frame
		repeat 
			health=select(1, frame:GetChildren())
			local name=health.name:GetText()
			health.name:SetPoint("LEFT", health, "LEFT", 0, 0)
			while health:GetNumChildren()>0 do
				local child=select(1, health:GetChildren())
				if child.text then child.text:SetText("") end
				child:SetParent(nil)
				child:Hide()
				child:SetBackdrop({})
			end
			if select(ChildrenFrames+1, frame:GetChildren()) then 
				frame=select(ChildrenFrames+1, frame:GetChildren()) 
			else
				frame=nil
			end
		until not frame
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute RemoveTargetFrames")
	--end
end

function SetTargetFrames()
	--debugprofilestart()
	RemoveTargetFrames()
	PlayerIsTargeted={}
	--I need to count how many players are targeting each enemy player, and set PlayerIsTargeted[name] to true for all enemy player names that have targets.
	local name, realm, Tname, Trealm, Aname, Arealm, Rname, Rrealm, Rhealth, Rhealthmax, player, rank, role
	local TargetCount={ }
	local function FormatName(name, realm)
		if name==nil then 
			name=""
		elseif realm and realm~="" then
			name=name.."-"..realm
			if string.len(name)>StringMaxLength then name=string.sub(name, 1, StringMaxLength) end
		end
		if name=="Nachta" then name="Nach'ta" end
		if not ShowServerWork and string.find(name, "-") then 
			local stop=strfind(name, "-")-1
			name=string.sub(name, 1, stop)
		end
		return name
	end
	if instancetype=="pvp" then --We are in a bg
		--print("=============SCANNING FOR FLAG CARRIERS============")
		for i=1, 5 do
			local FCname, FCrealm=UnitName("arena"..i)
			if FCname then FCname=FormatName(FCname, FCrealm) end
			--if FCname then print(FCname, "is the flag carrier.") end
			--if PlayerNamesDisplayed[FCname] then print("frame exists") end
			if FCname then
				if TargetCount[FCname] then
					TargetCount[FCname]=TargetCount[FCname]+1
				else
					TargetCount[FCname]=0
				end
				CreateTargetFrame(FCname, TargetCount[FCname], "Flag Carrier", nil, "arena"..i, nil)
			end
		end
	end
	if UnitInRaid("player") then
		for i=1, GetNumGroupMembers() do
			player, rank, _, _, _, _, _, _, _, role = GetRaidRosterInfo(i)
			name=nil
			realm=nil
			if rank==2 or role=="MAINTANK" or role=="MAINASSIST" then 
				name, realm=UnitName("raid"..i.."target")
				name=FormatName(name, realm)
				if rank==2 then role="LEADER" end
				if TargetCount[name] then
					TargetCount[name]=TargetCount[name]+1
				else
					TargetCount[name]=0
				end
				CreateTargetFrame(name, TargetCount[name], role, "raid" .. i, nil)
			end
			HandleName("raid" .. i .. "target")
		end	
	elseif UnitInParty("player") then
		name, realm=UnitName("party1target")
		name=FormatName(name, realm)
		CreateTargetFrame(name, 0, "LEADER", "party1")
		HandleName("party1target")
		HandleName("party2target")
		HandleName("party3target")
		HandleName("party4target")
		HandleName("party5target")
	else
		name, realm=UnitName("target")
		name=FormatName(name, realm)
		CreateTargetFrame(name, 0, "LEADER", "player")
	end
	HandleName("target")
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute SetTargetFrames")
	--end
end

function AddFrame(sourceName)
	--debugprofilestart()
	local function CheckIfOk()
		local function FormatName(name, realm)
			if name==nil then 
				name=""
			elseif realm and realm~="" then
				name=name.."-"..realm
				if string.len(name)>StringMaxLength then name=string.sub(name, 1, StringMaxLength) end
			end
			if name=="Nachta" then name="Nach'ta" end
			return name
		end
		if UnitInRaid("player") then
			for i=1, GetNumGroupMembers() do
				local name, realm=UnitName("raid"..i)
				name=FormatName(name, realm)
				if name==sourceName then return false end
			end	
		elseif UnitInParty("player") then
			for i=1, 5 do
				local name, realm=UnitName("party" .. i)
				name=FormatName(name, realm)
				if name==sourceName then return false end
			end
		end
		if HealersOnly then
			if ClassByName[sourceName] then
				if ClassByName[sourceName][3] then
					if NameColors[ClassByName[sourceName][3]] then
						--print(ClassByName[sourceName][3])
						--print(unpack(NameColors[ClassByName[sourceName][3]]))
						--print(unpack(Green))
						if unpack(NameColors[ClassByName[sourceName][3]])==unpack(Green) then
							--return true Do Nothing.  I may filter this player out as a friendly player.
						else
							--print(sourceName, "failed to be a healer")
							return false

						end
					else
						--print(sourceName, "failed to be a tank or healer.")
						return false
					end
				else
					--print(sourceName, "failed to have a spec.")
					return false
				end
			else
				--print(sourceName, "failed to have ClassByName")
				return false
			end
		end
		if instancetype=="arena" and not ArenaWork then return false end
		if instancetype=="pvp" and not BGWork then return false end
		if not WPvPWork and (not (instancetype=="pvp") or not (instancetype=="arena")) then return false end
		return true
	end
	if CheckIfOk() then
		if not UnitAura("player", "Dominate Mind") then
			PlayerNamesDisplayed[sourceName]=true
			--Finding the current last frame in the chain
			if DB2 then print("We are", UnitAffectingCombat("player")," in combat.", sourceName, "is", PlayerTargetable[sourceName], "targetable. Frame existance is", _G["PlayerFrame" .. sourceName]) end
			CurrentParent=mainframe
			if DB1 then print("I see", CurrentParent:GetNumChildren(), "frames off of mainframe") end
			if CurrentParent:GetNumChildren()>MainFrameChildren then --There are player frames in existance
				CurrentParent=select(MainFrameChildren+1, CurrentParent:GetChildren()) --frame is now the first player frame
				local health=select(1, CurrentParent:GetChildren())
				local name=health.name:GetText()
				if DB1 then print("I set the parent frame to be the frame named", name) end
				repeat 
					local NextFrameExists
					if CurrentParent:GetNumChildren()>ChildrenFrames then 
						CurrentParent=select(ChildrenFrames+1, CurrentParent:GetChildren()) 
						health=select(1, CurrentParent:GetChildren())
						name=health.name:GetText()
						if DB1 then print("I went to the next player frame, named", name) end
						NextFrameExists=true
					else
						NextFrameExists=false
					end
				until not NextFrameExists
			end 
			if _G["PlayerFrame" .. sourceName] then --Frame exists 
				if not _G["PlayerFrame" .. sourceName]:GetParent() then 
					NumberOfFramesActive=NumberOfFramesActive+1
					local health
					local name
					if NumberOfFramesActive==1 then
						name="mainframe"
					else
						health=select(1, CurrentParent:GetChildren())
						if health then name=health.name:GetText() else name="?" end
					end
					if DB1 then print("There should be", NumberOfFramesActive, "frames active.") end
					if DB1 then print("frame for", sourceName, "exists and will show now, attached to parent, named", name) end
					_G["PlayerFrame" .. sourceName] :Show()
					_G["PlayerFrame" .. sourceName] :SetParent(CurrentParent)
					if NumberOfFramesActive==1 then
						_G["PlayerFrame" .. sourceName]:SetPoint("TOP", CurrentParent, "TOP")
						if DB1 then print("anchoring frame to top of parent frame") end
					else
						_G["PlayerFrame" .. sourceName]:SetPoint("TOP", CurrentParent, "BOTTOM")
						if DB1 then print("anchoring frame to bottom of parent frame") end
						
					end
					CurrentParent=_G["PlayerFrame" .. sourceName] 
				else --Frame exists and has parent.
					if DB1 then print("frame for", sourceName, "exists and is already showing.") end
				end
			else --No frame exists for this player yet, shown or hidden
				--PlayerNamesList[table.maxn(PlayerNamesList)+1]=sourceName
				--print("added", sourceName,"to the names list.")
				NumberOfFramesActive=NumberOfFramesActive+1
				if DB1 then print("Creating a new frame for", sourceName) end
				if DB1 then print("There should be", NumberOfFramesActive, "frames active.") end
				_G["PlayerFrame" .. sourceName]=CreateFrame("Frame", nil, CurrentParent)
				PlayerTargetable[sourceName]=false
				_G["PlayerFrame" .. sourceName]:SetWidth(XSize)
				_G["PlayerFrame" .. sourceName]:SetHeight(CurrentFrameHeight)
				if NumberOfFramesActive==1 then
					_G["PlayerFrame" .. sourceName]:SetPoint("TOP", CurrentParent, "TOP")
				else
					_G["PlayerFrame" .. sourceName]:SetPoint("TOP", CurrentParent, "BOTTOM")
				end
				_G["PlayerFrame" .. sourceName]:Show()
				_G["PlayerFrame" .. sourceName]:SetBackdrop({
			       bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", tile=false})
				CurrentParent=_G["PlayerFrame" .. sourceName]
				
				--Creation of Health Bar, 1st child of player frame
				_G["PlayerFrame" .. sourceName .. "Health"] = CreateFrame("StatusBar", nil, _G["PlayerFrame" .. sourceName])
				_G["PlayerFrame" .. sourceName .. "Health"]:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
				_G["PlayerFrame" .. sourceName .. "Health"]:GetStatusBarTexture():SetHorizTile(false)
				_G["PlayerFrame" .. sourceName .. "Health"]:SetPoint("TOP",_G["PlayerFrame" .. sourceName],"TOP")
				_G["PlayerFrame" .. sourceName .. "Health"]:SetMinMaxValues(0,100)
				--Creation of name on health bar, child of health bar
				_G["PlayerFrame" .. sourceName .. "Health"].name=_G["PlayerFrame" .. sourceName .. "Health"]:CreateFontString(nil, "OVERLAY")
				_G["PlayerFrame" .. sourceName .. "Health"].name:SetPoint("LEFT", _G["PlayerFrame" .. sourceName .. "Health"], "LEFT")
				_G["PlayerFrame" .. sourceName .. "Health"].name:SetFont("Fonts\\FRIZQT__.TTF", FontSize, "OUTLINE")
				_G["PlayerFrame" .. sourceName .. "Health"].name:SetJustifyH("LEFT")
				_G["PlayerFrame" .. sourceName .. "Health"].name:SetText(sourceName)
				--Creation of hp text
				_G["PlayerFrame" .. sourceName .. "Health"].value=_G["PlayerFrame" .. sourceName .. "Health"]:CreateFontString(nil, "OVERLAY")
				_G["PlayerFrame" .. sourceName .. "Health"].value:SetPoint("RIGHT", _G["PlayerFrame" .. sourceName .. "Health"], "RIGHT")
				_G["PlayerFrame" .. sourceName .. "Health"].value:SetFont("Fonts\\FRIZQT__.TTF", HPFont, "OUTLINE")
				_G["PlayerFrame" .. sourceName .. "Health"].value:SetJustifyH("LEFT")
				_G["PlayerFrame" .. sourceName .. "Health"].value:SetShadowOffset(1, -1)
				_G["PlayerFrame" .. sourceName .. "Health"].value:SetText("??")
				_G["PlayerFrame" .. sourceName .. "Health"].value:SetTextColor(1,1,1)
				--Creation of pvp trinket, 2nd child of player frame
				_G["PlayerFrame" .. sourceName .. "Trinket"] = CreateFrame("Frame", nil, _G["PlayerFrame" .. sourceName])
				_G["PlayerFrame" .. sourceName .. "Trinket"]:SetPoint("TOPRIGHT",_G["PlayerFrame" .. sourceName],"TOPRIGHT")
				_G["PlayerFrame" .. sourceName .. "Trinket"]:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/Trinket",
					edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
					tile = false, tileSize = 16, edgeSize = 16, 
					insets = { left = 4, right = 4, top = 4, bottom = 4 }});
				--Creation of "cooldown frame" on top of the frame.
				_G["PlayerFrame" .. sourceName .. "Trinket"].cooldown=CreateFrame("Cooldown", nil, _G["PlayerFrame" .. sourceName .. "Trinket"], "CooldownFrameTemplate")
				_G["PlayerFrame" .. sourceName .. "Trinket"].cooldown:SetAllPoints()
				if PlayerTrinketTimes[sourceName] then
					if GetTime()-PlayerTrinketTimes[sourceName]<120 then
						_G["PlayerFrame" .. sourceName .. "Trinket"].cooldown:SetCooldown(PlayerTrinketTimes[sourceName], 120)
					end
				end
				--Creation of text on PvP trinket
				_G["PlayerFrame" .. sourceName .. "Trinket"].number=_G["PlayerFrame" .. sourceName .. "Trinket"]:CreateFontString(nil, "OVERLAY")
				_G["PlayerFrame" .. sourceName .. "Trinket"].number:SetPoint("Center", _G["PlayerFrame" .. sourceName .. "Trinket"], "CENTER")
				_G["PlayerFrame" .. sourceName .. "Trinket"].number:SetFont("Fonts\\FRIZQT__.TTF", TrinketFont, "OUTLINE")
				_G["PlayerFrame" .. sourceName .. "Trinket"].number:SetJustifyH("CENTER")
				--Creation of Class/Spec icon, 3rd child of player frame
				_G["PlayerFrame" .. sourceName .. "Class"] = CreateFrame("Frame", nil, _G["PlayerFrame" .. sourceName])
				_G["PlayerFrame" .. sourceName .. "Class"]:SetPoint("TOPLEFT",_G["PlayerFrame" .. sourceName],"TOPLEFT")
				_G["PlayerFrame" .. sourceName .. "Class"]:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/Unknown", tile=false});
				--Creation of five frames for DR display, 4th, 5th, 6th, 7th, and 8th children of player frame
				_G["PlayerFrame" .. sourceName .. "Root"] = CreateFrame("Frame", nil, _G["PlayerFrame" .. sourceName])
				_G["PlayerFrame" .. sourceName .. "Root"]:SetPoint("RIGHT",_G["PlayerFrame" .. sourceName],"LEFT")
				
				_G["PlayerFrame" .. sourceName .. "Root"].number=_G["PlayerFrame" .. sourceName .. "Root"]:CreateFontString(nil, "OVERLAY")
				_G["PlayerFrame" .. sourceName .. "Root"].number:SetPoint("Center", _G["PlayerFrame" .. sourceName .. "Root"], "CENTER")
				_G["PlayerFrame" .. sourceName .. "Root"].number:SetFont("Fonts\\FRIZQT__.TTF", DRFont, "OUTLINE")
				_G["PlayerFrame" .. sourceName .. "Root"].number:SetJustifyH("CENTER")
				
				_G["PlayerFrame" .. sourceName .. "Stun"] = CreateFrame("Frame", nil, _G["PlayerFrame" .. sourceName])
				_G["PlayerFrame" .. sourceName .. "Stun"]:SetPoint("RIGHT",_G["PlayerFrame" .. sourceName],"LEFT")
				
				_G["PlayerFrame" .. sourceName .. "Stun"].number=_G["PlayerFrame" .. sourceName .. "Stun"]:CreateFontString(nil, "OVERLAY")
				_G["PlayerFrame" .. sourceName .. "Stun"].number:SetPoint("Center", _G["PlayerFrame" .. sourceName .. "Stun"], "CENTER")
				_G["PlayerFrame" .. sourceName .. "Stun"].number:SetFont("Fonts\\FRIZQT__.TTF", DRFont, "OUTLINE")
				_G["PlayerFrame" .. sourceName .. "Stun"].number:SetJustifyH("CENTER")
				
				_G["PlayerFrame" .. sourceName .. "Horror"] = CreateFrame("Frame", nil, _G["PlayerFrame" .. sourceName])
				_G["PlayerFrame" .. sourceName .. "Horror"]:SetPoint("RIGHT",_G["PlayerFrame" .. sourceName],"LEFT")
				
				_G["PlayerFrame" .. sourceName .. "Horror"].number=_G["PlayerFrame" .. sourceName .. "Horror"]:CreateFontString(nil, "OVERLAY")
				_G["PlayerFrame" .. sourceName .. "Horror"].number:SetPoint("Center", _G["PlayerFrame" .. sourceName .. "Horror"], "CENTER")
				_G["PlayerFrame" .. sourceName .. "Horror"].number:SetFont("Fonts\\FRIZQT__.TTF", DRFont, "OUTLINE")
				_G["PlayerFrame" .. sourceName .. "Horror"].number:SetJustifyH("CENTER")
				
				_G["PlayerFrame" .. sourceName .. "Fear"] = CreateFrame("Frame", nil, _G["PlayerFrame" .. sourceName])
				_G["PlayerFrame" .. sourceName .. "Fear"]:SetPoint("RIGHT",_G["PlayerFrame" .. sourceName],"LEFT")
				
				_G["PlayerFrame" .. sourceName .. "Fear"].number=_G["PlayerFrame" .. sourceName .. "Fear"]:CreateFontString(nil, "OVERLAY")
				_G["PlayerFrame" .. sourceName .. "Fear"].number:SetPoint("Center", _G["PlayerFrame" .. sourceName .. "Fear"], "CENTER")
				_G["PlayerFrame" .. sourceName .. "Fear"].number:SetFont("Fonts\\FRIZQT__.TTF", DRFont, "OUTLINE")
				_G["PlayerFrame" .. sourceName .. "Fear"].number:SetJustifyH("CENTER")
				
				_G["PlayerFrame" .. sourceName .. "Silence"] = CreateFrame("Frame", nil, _G["PlayerFrame" .. sourceName])
				_G["PlayerFrame" .. sourceName .. "Silence"]:SetPoint("RIGHT",_G["PlayerFrame" .. sourceName],"LEFT")
				
				_G["PlayerFrame" .. sourceName .. "Silence"].number=_G["PlayerFrame" .. sourceName .. "Silence"]:CreateFontString(nil, "OVERLAY")
				_G["PlayerFrame" .. sourceName .. "Silence"].number:SetPoint("Center", _G["PlayerFrame" .. sourceName .. "Silence"], "CENTER")
				_G["PlayerFrame" .. sourceName .. "Silence"].number:SetFont("Fonts\\FRIZQT__.TTF", DRFont, "OUTLINE")
				_G["PlayerFrame" .. sourceName .. "Silence"].number:SetJustifyH("CENTER")
				--Creation of player count frame, the 9th child of the player frame
				_G["PlayerFrame" .. sourceName .. "Counter"] = CreateFrame("Frame", nil, _G["PlayerFrame" .. sourceName])
				_G["PlayerFrame" .. sourceName .. "Counter"]:SetPoint("RIGHT",_G["PlayerFrame" .. sourceName],"LEFT")
				_G["PlayerFrame" .. sourceName .. "Counter"]:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/Blank2", tile=false});
				_G["PlayerFrame" .. sourceName .. "Counter"].number=_G["PlayerFrame" .. sourceName .. "Counter"]:CreateFontString(nil, "OVERLAY")
				_G["PlayerFrame" .. sourceName .. "Counter"].number:SetPoint("Center", _G["PlayerFrame" .. sourceName .. "Counter"], "CENTER")
				_G["PlayerFrame" .. sourceName .. "Counter"].number:SetFont("Fonts\\FRIZQT__.TTF", DRFont, "OUTLINE")
				_G["PlayerFrame" .. sourceName .. "Counter"].number:SetJustifyH("CENTER")
				_G["PlayerFrame" .. sourceName .. "Counter"]:Hide()
			end
			AdjustFrameHeights()
			SetClassFrame(sourceName)
			SetFrameColors(sourceName)
			PlayerLastActive[sourceName]=GetTime()
			RefreshFrames()
			UpgradeFrames(true)
		end
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute AddFrame")
	--end
end

function RemoveFrame(name)
	--debugprofilestart()
	if _G["PlayerFrame" .. name] then
		--print("Status of player frame", PlayerNamesDisplayed[name], "Status of frame of player", _G["PlayerFrame" .. name])
		if _G["PlayerFrame" .. name]:IsShown() then --Frame exists.  Must attach children to the parent and remove frame from the chain
			NumberOfFramesActive=NumberOfFramesActive-1
			if DB1 then print("attempting to remove frame for", name, ". ", NumberOfFramesActive, "will be active.") end
			
			
			parent=_G["PlayerFrame" .. name]:GetParent()
			local parentname
			if parent then
				if parent:GetNumChildren()<=1 then --The parent is the main frame
					parentname="mainframe"
				else
					local health=select(1, parent:GetChildren())
					if health then
						if health.name then 
							parentname=health.name:GetText() 
						else 
							parentname=nil
						end
					else
						parentname=nil
					end
				end
			else
				if DB1 then print("Found parent to be nil for this frame.") end
			end
			if DB1 then print("Parent is", parentname) end
			_G["PlayerFrame" .. name]:SetParent(mainframe) --Changing this parent removes a child from the previous frame
			if _G["PlayerFrame" .. name]:GetNumChildren()==ChildrenFrames+1 then --Children player frames exist
				if DB1 then print("Frame has frames afterwards.  Need to move them.") end
				playerchild=select(ChildrenFrames+1, _G["PlayerFrame" .. name]:GetChildren())
				playerchild:SetParent(parent)
				if parent==mainframe then
					playerchild:SetPoint("TOP", parent, "TOP")
					if DB1 then print("Frame was the first one.  Attaching to top of mainframe.") end
				else
					playerchild:SetPoint("TOP", parent, "BOTTOM")
					if DB1 then print("Parent was not mainframe.  Attaching to bottom of previous.") end
				end
			else
				CurrentParent=parent
				if DB1 then print("Frame was last in chain.  No need to move children.") end
			end
			PlayerNamesDisplayed[name]=nil
			_G["PlayerFrame" .. name]:Hide()
			_G["PlayerFrame" .. name]:SetParent(nil)
			PlayerHealth[name]=nil
			PlayerMaxHealth[name]=nil
		end
		UpdateTrinketDisplay() --This is to get it from momentarily showing frames at the bottom.  Fixes a bug, unsure why it works.
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute RemoveFrame")
	--end
end

function RemoveOldFrames()
	--debugprofilestart()
	local frame=mainframe
	if frame:GetNumChildren()>MainFrameChildren then --There are player frames in existance
		frame=select(2, frame:GetChildren()) --frame is now the first player frame
		repeat
			health=select(1, frame:GetChildren())
			local name=health.name:GetText()
			if frame:GetNumChildren()==ChildrenFrames+1 then
			--if select(ChildrenFrames+1, frame:GetChildren()) then
				frame=select(ChildrenFrames+1, frame:GetChildren())
			else
				frame=nil
			end
			if PlayerLastActive[name] then
				if GetTime()-PlayerLastActive[name]>DecayTime then
					if PlayerNamesDisplayed[name] then
						RemoveFrame(name)
					end
				end
			end
		until not frame
	end
	AdjustFrameHeights()
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute RemoveOldFrames")
	--end
end

function RemoveAllFrames()
	--debugprofilestart()
	local frame=mainframe
	while frame:GetNumChildren()>MainFrameChildren do
		if frame:GetNumChildren()>MainFrameChildren then --Frames exist to remove
			frame=select(MainFrameChildren+1, frame:GetChildren()) --frame is now the first frame
			health=select(1, frame:GetChildren())
			local name=health.name:GetText()
			RemoveFrame(name)
		end
		frame=mainframe
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute RemoveAllFrames")
	--end
end

function InsertFrame(name, child, endframe)
	--debugprofilestart()
	--print("attempting to insert", name, "above frame", child)
	if _G["PlayerFrame" .. name] then
		if _G["PlayerFrame" .. name]:GetParent()==nil then
			NumberOfFramesActive=NumberOfFramesActive+1
			_G["PlayerFrame" .. name]:Show()
			if _G["PlayerFrame" .. child] then
				local parent=_G["PlayerFrame" .. child]:GetParent()
				--if parent==mainframe then print("the parent is the main frame") end
				_G["PlayerFrame" .. child]:SetParent(_G["PlayerFrame" .. name])
				_G["PlayerFrame" .. name]:SetParent(parent)
				if parent==mainframe then 
					_G["PlayerFrame" .. name]:SetPoint("TOP", parent, "TOP")
				else
					_G["PlayerFrame" .. name]:SetPoint("TOP", parent, "BOTTOM")
				end
				_G["PlayerFrame" .. child]:SetPoint("TOP", _G["PlayerFrame" .. name], "BOTTOM")
			else
				print("I should never reach this point")
				_G["PlayerFrame" .. name]:SetParent(_G["PlayerFrame" .. endframe])
				if endframe==mainframe then 
					_G["PlayerFrame" .. name]:SetPoint("TOP", endframe, "TOP")
				else
					_G["PlayerFrame" .. name]:SetPoint("TOP", endframe, "BOTTOM")
				end
			end
		else
			print("InsertFrame called for frame with existant parent")
		end
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute InsertFrame")
	--end
end

function SortFrames(startpoint)
	--print("=========================================")
	--debugprofilestart()
	local function Priority(class, spec, name)
		local score=0
		if SortStyle==1 then --Role, Class, Name
			if spec then
				score=SpecWeights[spec]
			elseif class then
				score=SpecWeights[class]
			else
				score=100
			end
		elseif SortStyle==3 then --Class, then Name
			if class then 
				score=SpecWeights[class]
			else
				score=100
			end
		end
		--Alpabetical strictly
		name=string.lower(name)
		for i=1, string.len(name) do
			local char=string.sub(name, i, i)
			local ascii=string.byte(char, 1)
			score=score+(ascii/255)*1/(255^(i-1))
		end
		--print(name, "scored a", score)
		return score
	end
	if not CombatStatus or not ClickableFrames or (RaidNoClick and not (instancetype=="pvp") and not (instancetype=="arena") and UnitInRaid("player")) then
		if startpoint==mainframe then startpoint=select(MainFrameChildren+1, startpoint:GetChildren()) end
		--We are selecting a player frame, the one of which we wish to start sorting now.
		local currentpoint=startpoint
		local score={}
		while currentpoint do 
			local health=select(1, currentpoint:GetChildren())
			local name=health.name:GetText()
			local spec, class
			if ClassByName[name] then
				spec=ClassByName[name][3]
				class=ClassByName[name][1]
			else
				spec=nil
				class=nil
			end
			score[name]=Priority(class, spec, name)
			local insertpoint=mainframe
			insertpoint=select(MainFrameChildren+1, insertpoint:GetChildren())--Start at beginning
			
			local framesbefore=0
			while not (insertpoint==currentpoint) do
				local ihealth=select(1, insertpoint:GetChildren())
				local iname=ihealth.name:GetText()
				--print(iname, score[iname])
				if score[iname]>score[name] then
					--print("Need to insert", name, "before", iname)
					RemoveFrame(name)
					InsertFrame(name, iname, nil)
					break
				end
				insertpoint=select(ChildrenFrames+1, insertpoint:GetChildren())
				framesbefore=framesbefore+1
			end
			--print("found", framesbefore, "frames before", name, score[name])
			currentpoint=select(ChildrenFrames+1, currentpoint:GetChildren())
		end
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute SortFrames")
	--end
end

function AdjustFrameHeights()
	--debugprofilestart()
	if not CombatStatus or not ClickableFrames or (RaidNoClick and not (instancetype=="pvp") and not (instancetype=="arena") and UnitInRaid("player")) then CalculateFrameHeights() end
	local offset=0
	if not TrinketWork then offset=offset+CurrentFrameHeight/2 end
	if not ClassIconWork then offset=offset-CurrentFrameHeight/2 end
	local size=0
	if not TrinketWork then size=size+CurrentFrameHeight end
	if not ClassIconWork then size=size+CurrentFrameHeight end
	local height=math.min(CurrentFrameHeight*TFScale, TFMax)
	--[[
	LeaderTargetFrame:SetHeight(height)
	LeaderTargetFrame:SetWidth(height)
	LeaderTargetFrame:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/Leader", 
					    edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
					    tile = false, tileSize = TFMax/4, edgeSize = TFMax/4, 
					    insets = { left = TFMax/10, right = TFMax/10, top = TFMax/10, bottom = TFMax/10 }})
	TankTargetFrame:SetHeight(height)
	TankTargetFrame:SetWidth(height)
	TankTargetFrame:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/Tank", 
					    edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
					    tile = false, tileSize = TFMax/4, edgeSize = TFMax/4, 
					    insets = { left = TFMax/10, right = TFMax/10, top = TFMax/10, bottom = TFMax/10 }})
	AssistTargetFrame:SetHeight(height)
	AssistTargetFrame:SetWidth(height)
	AssistTargetFrame:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/Assist", 
					    edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
					    tile = false, tileSize = TFMax/4, edgeSize = TFMax/4, 
					    insets = { left = TFMax/10, right = TFMax/10, top = TFMax/10, bottom = TFMax/10 }})--]]
	local frame=mainframe
	if frame:GetNumChildren()>MainFrameChildren  then --There are player frames in existance 
		local RealFrameHeight=CurrentFrameHeight
		frame=select(MainFrameChildren+1, frame:GetChildren()) --frame is now the first player frame
		if PlayerTargetFrame:IsShown() then 
			PlayerTargetFrame:SetWidth(XSize+cursorscale)
			PlayerTargetFrame:SetHeight(CurrentFrameHeight+cursorscale)
			PlayerTargetFrame:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
							tile = false, tileSize = 16, edgeSize = 16, 
							insets = { left = 4, right = 4, top = 4, bottom = 4 }})	
		end
		repeat 
			frame:SetHeight(RealFrameHeight)
			frame:SetWidth(XSize)
			health=select(1, frame:GetChildren())
			local sourceName=health.name:GetText()
			
			local DRText
			if (0.7*RealFrameHeight)<DRFont then
				DRText=(math.max((0.7*RealFrameHeight), 1))
			else
				DRText=DRFont
			end
			_G["PlayerFrame" .. sourceName .. "Root"]:SetHeight(CurrentFrameHeight)
			_G["PlayerFrame" .. sourceName .. "Root"]:SetWidth(CurrentFrameHeight)
			_G["PlayerFrame" .. sourceName .. "Root"].number:SetFont("Fonts\\FRIZQT__.TTF", DRText, "OUTLINE")
			_G["PlayerFrame" .. sourceName .. "Stun"]:SetHeight(CurrentFrameHeight)
			_G["PlayerFrame" .. sourceName .. "Stun"]:SetWidth(CurrentFrameHeight)
			_G["PlayerFrame" .. sourceName .. "Stun"].number:SetFont("Fonts\\FRIZQT__.TTF", DRText, "OUTLINE")
			_G["PlayerFrame" .. sourceName .. "Horror"]:SetHeight(CurrentFrameHeight)
			_G["PlayerFrame" .. sourceName .. "Horror"]:SetWidth(CurrentFrameHeight)
			_G["PlayerFrame" .. sourceName .. "Horror"].number:SetFont("Fonts\\FRIZQT__.TTF", DRText, "OUTLINE")
			_G["PlayerFrame" .. sourceName .. "Fear"]:SetHeight(CurrentFrameHeight)
			_G["PlayerFrame" .. sourceName .. "Fear"]:SetWidth(CurrentFrameHeight)
			_G["PlayerFrame" .. sourceName .. "Fear"].number:SetFont("Fonts\\FRIZQT__.TTF", DRText, "OUTLINE")
			_G["PlayerFrame" .. sourceName .. "Silence"]:SetHeight(CurrentFrameHeight)
			_G["PlayerFrame" .. sourceName .. "Silence"]:SetWidth(CurrentFrameHeight)
			_G["PlayerFrame" .. sourceName .. "Silence"].number:SetFont("Fonts\\FRIZQT__.TTF", DRText, "OUTLINE")
			
			_G["PlayerFrame" .. sourceName .. "Counter"]:SetHeight(CurrentFrameHeight)
			_G["PlayerFrame" .. sourceName .. "Counter"]:SetWidth(CurrentFrameHeight)
			_G["PlayerFrame" .. sourceName .. "Counter"].number:SetFont("Fonts\\FRIZQT__.TTF", DRText, "OUTLINE")

			PlayerTargetFrame:SetBackdrop({edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
							tile = false, tileSize = 16*CurrentFrameHeight/27, edgeSize = 16*CurrentFrameHeight/27, 
							insets = { left = 4*CurrentFrameHeight/27, right = 4*CurrentFrameHeight/27, top = 4*CurrentFrameHeight/27, bottom = 4*CurrentFrameHeight/27 }})	
			
			trinket=select(2, frame:GetChildren())
			class=select(3, frame:GetChildren())
			if health then
				health:SetHeight(HPHeight*RealFrameHeight)
				health:SetWidth(math.min(XSize-(1+HPHeight)*RealFrameHeight)+size)
				health:SetPoint("TOP", frame, "TOP", offset, 0)
				if health:GetNumChildren()==1 then
					local button=select(1, health:GetChildren())
					button:SetHeight(HPHeight*RealFrameHeight)
					button:SetWidth(math.min(XSize-(1+HPHeight)*RealFrameHeight))
				end
				if trinket then
					trinket:SetHeight(RealFrameHeight)
					trinket:SetWidth(RealFrameHeight)
					if TrinketWork then trinket:Show() else trinket:Hide() end
					trinket:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/Trinket",
						edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
						tileSize = 16*RealFrameHeight/50, edgeSize = 16*RealFrameHeight/50, 
						insets = { left = 4*RealFrameHeight/50, right = 4*RealFrameHeight/50,
						top = 4*RealFrameHeight/50, bottom = 4*RealFrameHeight/50 }});
					if trinket.number then
						if (0.5*RealFrameHeight)<TrinketFont then
							trinket.number:SetFont("Fonts\\FRIZQT__.TTF", math.floor(math.max((0.5*RealFrameHeight), 1)), "OUTLINE")
						else
							trinket.number:SetFont("Fonts\\FRIZQT__.TTF", TrinketFont, "OUTLINE")
						end
					end
				end
				if class then
					class:SetHeight(HPHeight*RealFrameHeight)
					class:SetWidth(HPHeight*RealFrameHeight)
					if ClassIconWork then class:Show() else class:Hide() end
				end
				if health then
					if health.name then
						if RealFrameHeight<FontSize then 
							health.name:SetFont("Fonts\\FRIZQT__.TTF", math.floor(math.max(RealFrameHeight, 1)), "OUTLINE")
						else
							health.name:SetFont("Fonts\\FRIZQT__.TTF", FontSize, "OUTLINE")
						end
					end
					if health.value then
						health.value:SetFont("Fonts\\FRIZQT__.TTF", HPFont, "OUTLINE")
					end
					if health.value then
						if RealFrameHeight<HPFont then
							health.value:SetFont("Fonts\\FRIZQT__.TTF", math.floor(math.max(RealFrameHeight, 1)), "OUTLINE")
						else
							health.value:SetFont("Fonts\\FRIZQT__.TTF", HPFont, "OUTLINE")
						end
					end
				end
			end
			if select(ChildrenFrames+1, frame:GetChildren()) then 
				frame=select(ChildrenFrames+1, frame:GetChildren()) 
			else
				frame=nil
			end
		until not frame
	end
	UpgradeFrames()
	SetTargetFrames()
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute AdjustFrameHeights")
	--end
end

function SetFrameColors(playername)
	--debugprofilestart()
	if _G["PlayerFrame" .. playername .. "Health"] then
		local T
		if PlayerLastActive[playername] then
			T=1-math.min((math.min(GetTime()-PlayerLastActive[playername], DecayTime))/DecayTime), 0 --Will range from 1 to 0 as time past goes from 0 to DecayTime
		else
			T=1
		end
		T=math.min(1, T*1.25)
		if string.find(playername, "Predatoria") then --Special color for myself
			_G["PlayerFrame" .. playername .. "Health"]:SetStatusBarColor(T*187/255, T*230/255, T*237/255) 
			--SetStatusBarColor(212/255, 249/255, 255/255) 
		elseif string.find(playername, "Nach'ta") then
			_G["PlayerFrame" .. playername .. "Health"]:SetStatusBarColor(T*255/255, T*79/255, T*10/255) 
		elseif ClassByName[playername] then --Know or suspect a class for this player
			if _G["PlayerFrame" .. playername .. "Health"] then
				if (ClassByName[playername])[1] and ClassColors[(ClassByName[playername])[1]] then
					_G["PlayerFrame" .. playername .. "Health"]:SetStatusBarColor(T*(ClassColors[(ClassByName[playername])[1]])[1], T*(ClassColors[(ClassByName[playername])[1]])[2], T*(ClassColors[(ClassByName[playername])[1]])[3])
				else
					_G["PlayerFrame" .. playername .. "Health"]:SetStatusBarColor(T*0.5, T*0.5, T*0.5) 
				end
			end
		else                                             --Don't know class for this player
			if _G["PlayerFrame" .. playername .. "Health"] then _G["PlayerFrame" .. playername .. "Health"]:SetStatusBarColor(T*0.5, T*0.5, T*0.5) end
		end
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute SetFrameColors")
	--end
end

function SetClassFrame(playername)
	--debugprofilestart()
	local guild=PlayerGuilds[playername]
	if _G["PlayerFrame" .. playername .. "Class"] then --the frame exists
		if ClassByName[playername] then
			if (guild=="Warsong Battalion" or guild=="Division VII" or guild=="Chaos" or guild=="Warforged Legion") and StarchMode then
				local n=string.lower(playername)
				n=string.sub(n, 1, 1)
				local ascii=string.byte(n, 1)
				local index=ascii - math.floor(ascii/2)*2 + 1
				_G["PlayerFrame" .. playername .. "Class"]:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/Potato" .. index, tile=false})
				--_G["PlayerFrame" .. playername .. "Class"]:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/Potato", tile=false})
			elseif string.find(playername, "Predatoria") then --Giving myself a special icon
				_G["PlayerFrame" .. playername .. "Class"]:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/Predatoria", tile=false})
				_G["PlayerFrame" .. playername .. "Health"].name:SetTextColor(255/255, 255/255, 255/255)
			elseif string.find(playername, "Nach'ta") then --Giving myself a special icon
				_G["PlayerFrame" .. playername .. "Class"]:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/Nachta", tile=false})
				_G["PlayerFrame" .. playername .. "Health"].name:SetTextColor(133/255, 90/255, 73/255)
			elseif (ClassByName[playername])[3] then --We know the spec
				local filepath="Interface/AddOns/HelloAce/Icons/" .. (ClassByName[playername])[3]
				if NameColors[(ClassByName[playername][3])] then --Player is tank or healer
					_G["PlayerFrame" .. playername .. "Health"].name:SetTextColor(unpack(NameColors[(ClassByName[playername][3])], 1, 3))
				else	--Player is a dps
					_G["PlayerFrame" .. playername .. "Health"].name:SetTextColor(unpack(Red, 1, 3))
				end
				_G["PlayerFrame" .. playername .. "Class"]:SetBackdrop({bgFile = filepath, tile=false})
			elseif (ClassByName[playername])[1] then  --We don't know the spec but know the class
				local filepath="Interface/AddOns/HelloAce/Icons/" .. (ClassByName[playername])[1]
				_G["PlayerFrame" .. playername .. "Class"]:SetBackdrop({bgFile = filepath, tile=false})
			else --We don't know the spec or class
				_G["PlayerFrame" .. playername .. "Class"]:SetBackdrop({bgFile = "Interface/AddOns/HelloAce/Icons/Unknown", tile=false})
			end
		end
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute SetClassFrame")
	--end
end

function UpdateTrinketDisplay()
	--debugprofilestart()
	local frame=mainframe
	local NumberOfFramesActive=0
	if frame:GetNumChildren()>MainFrameChildren then --There are player frames in existance
		frame=select(MainFrameChildren+1, frame:GetChildren()) --frame is now the first player frame
		frame:SetPoint("TOP", mainframe, "TOP") --Fixing a bug that appeared 
		NumberOfFramesActive=1
		repeat 
			health=select(1, frame:GetChildren())
			local name
			if health.name then 
				name=health.name:GetText()
			else
				name="??"
			end
			PlayerNamesDisplayed[name]=true
			trinket=select(2, frame:GetChildren())
			if trinket then
				if PlayerTrinketTimes[name] then
					if GetTime()-PlayerTrinketTimes[name]<120 then
						local time=120-(GetTime()-PlayerTrinketTimes[name])
						local text=string.format("%.0f", time)
						trinket.number:SetText(text)
						trinket.number:SetTextColor(2*time/120, -2*time/120+2, 0)
					else
						trinket.number:SetText("")
						trinket.number:SetTextColor(0,1,0)
					end
				else
					trinket.number:SetText("")
					trinket.number:SetTextColor(0,1,0)
				end
			end
			if select(ChildrenFrames+1, frame:GetChildren()) then 
				frame=select(ChildrenFrames+1, frame:GetChildren()) 
				NumberOfFramesActive=NumberOfFramesActive+1
			else
				frame=nil
			end
		until not frame
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute UpdateTrinketDisplay")
	--end
end

function SetHealthBars()
	--debugprofilestart()
	local frame=mainframe
	if frame:GetNumChildren()>MainFrameChildren then --There are player frames in existance
		frame=select(MainFrameChildren+1, frame:GetChildren()) --frame is now the first player frame
		repeat
			health=select(1, frame:GetChildren())
			local name
				if health then
					if health.name then
						name=health.name:GetText()
					else
						name="??"
					end
				else
					name="??"
				end
			if PlayerHealth[name] then
				local percent=PlayerHealth[name]/PlayerMaxHealth[name]*100
				local hp
				if HPStyle==1 then
					hp=string.format("%.0f%%", percent)
				elseif HPStyle==2 then
					hp=string.format("%.0fk", PlayerHealth[name]/1000)
				else
					hp=string.format("%.0fk / %.0fk", PlayerHealth[name]/1000, PlayerMaxHealth[name]/1000)
				end
				health.value:SetText(hp)
				local r
				local g
				local b
				local P=percent/100
				if P>0.67 then
					r=1
					g=(255-(255-196)*(1-P)/.33)/255
					b=(255-255*(1-P)/.33)/255
				elseif P>0.33 then
					r=255/255
					g=(196-(196-111)*(0.67-P)/.34)/255
					b=0
				else
					r=(255-(255-192)*(0.33-P)/.33)/255
					g=(111-111*(0.33-P)/0.33)/255
					b=0
				end
				if health then
					if health:GetObjectType()=="StatusBar" then
						health:SetValue(percent)
						if health.value then
							health.value:SetTextColor(r,g,b)
							if PercentageHPWork then health.value:Show() else health.value:Hide() end
						end
					end
				end
			else
				if health then
					if health:GetObjectType()=="StatusBar" then
						health:SetValue(100)
						if health.value then
							health.value:SetText("??")
							health.value:SetTextColor(1,1, 1)
							if PercentageHPWork then health.value:Show() else health.value:Hide() end
						end
					end
				end
			end
			if select(ChildrenFrames+1, frame:GetChildren()) then
				frame=select(ChildrenFrames+1, frame:GetChildren())
			else
				frame=nil
			end
		until not frame
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute SetHealthBars")
	--end
end

function UpgradeFrames(safe)
	--print("===============UPGRADE FRAMES============")
	--debugprofilestart()
	if not CombatStatus and ClickableFrames and (not (RaidNoClick and UnitInRaid("player")) or instancetype=="pvp" or instancetype=="battleground") then 
		--print("upgrading frames", CombatStatus, ClickableFrames, RaidNoClick, UnitInRaid("player"), instancetype)
		--print("Making Frames Clickable of height and width", CurrentFrameHeight, XSize)
		local FrameIndex=0
		local frame=mainframe
		local currentparent=nil
		CalculateFrameHeights()
		if frame:GetNumChildren()>MainFrameChildren then --There are player frames in existance
			frame=select(MainFrameChildren+1, frame:GetChildren()) --frame is now the first player frame
			currentparent=mainframe
			repeat
				FrameIndex=FrameIndex+1
				health=select(1, frame:GetChildren())
				local name
				if health then 
					if health.name then
						name=health.name:GetText()
					else
						name="??"
					end
				else
					name="??"
				end
				--print("got here")
				if name=="Nach'ta" then name = "Nachta" end
				if _G["PlayerButton" .. FrameIndex] then --Frame exists, set macro
				else --Frame doesnt exist, create frame
					_G["PlayerButton" .. FrameIndex]=CreateFrame("Button", nil, currentparent, "SecureActionButtonTemplate")
				end
				_G["PlayerButton" .. FrameIndex]:RegisterForClicks("AnyUp")
				_G["PlayerButton" .. FrameIndex]:SetAttribute("type1", "macro")
				_G["PlayerButton" .. FrameIndex]:SetAttribute("macrotext1", "/targetexact " .. name)
				_G["PlayerButton" .. FrameIndex]:SetAttribute("type2", "macro")
				--_G["PlayerButton" .. FrameIndex]:SetAttribute("macrotext2", "/targetexact "..name.."\n/focus\n/targetlasttarget")
				_G["PlayerButton" .. FrameIndex]:SetAttribute("macrotext2", "/targetexact "..name.."\n/focus\n/targetlasttarget")
				_G["PlayerButton" .. FrameIndex]:SetWidth(XSize)
				_G["PlayerButton" .. FrameIndex]:SetHeight(CurrentFrameHeight)
				if currentparent==mainframe then 
					_G["PlayerButton" .. FrameIndex]:SetPoint("TOP",currentparent , "TOP")
					--print("mainframe, anchor to top for", name)
				elseif ((FrameIndex-1)-5*math.floor((FrameIndex-1)/5))==0 then --6th, 11, 16, etc frame
					_G["PlayerButton" .. FrameIndex]:SetPoint("TOP", currentparent , "BOTTOM", 0, -SpacerSize*CurrentFrameHeight)
					--print("spacing before", name, "for click frame.")
				else
					_G["PlayerButton" .. FrameIndex]:SetPoint("TOP",currentparent , "BOTTOM")
					--print("no space", name, "normal click frame.")
				end
				_G["PlayerButton" .. FrameIndex]:Show()
				--if _G["PlayerButton" .. FrameIndex+1] then _G["PlayerButton" .. FrameIndex]:Hide() end
				--local child=_G["PlayerButton" .. FrameIndex]:GetChildren()
				--if child then
				--	child:Hide()
				--end
				currentparent=_G["PlayerButton" .. FrameIndex]
				if frame:GetNumChildren()==ChildrenFrames+1 then
				--if select(ChildrenFrames+1, frame:GetChildren()) then
					frame=select(ChildrenFrames+1, frame:GetChildren())
				else
					frame=nil
				end
				--print("The", FrameIndex, "th frame will target", name, "and is", _G["PlayerButton" .. FrameIndex]:IsShown())
			until not frame
			if _G["PlayerButton" .. FrameIndex+1] then _G["PlayerButton" .. FrameIndex+1]:Hide() end
		else --There are not player frames in existance.  Hide all.
			if _G["PlayerButton" .. 1] then _G["PlayerButton" .. 1]:Hide() end
		end
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute UpgradeFrames")
	--end
end

function CalculateFrameHeights()
	--debugprofilestart()
	if not CombatStatus or not ClickableFrames or (RaidNoClick and not (instancetype=="pvp") and not (instancetype=="arena") and UnitInRaid("player")) then
		local SpacerFrameCount=math.max(math.floor((NumberOfFramesActive-1)/5), 0)
		CurrentFrameHeight=math.min(YSize/(NumberOfFramesActive+SpacerFrameCount*SpacerSize), FrameHeight)
	end
	--print("Current frame height is", CurrentFrameHeight, "and combat status is", CombatStatus)
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute CalculateFrameHeights")
	--end
end

function RefreshFrames()
	--debugprofilestart()
	local frame=mainframe
	local NumberOfFramesActive=0
	local framecount=0
	CalculateFrameHeights()
	if frame:GetNumChildren()>MainFrameChildren then --There are player frames in existance
		frame=select(MainFrameChildren+1, frame:GetChildren()) --frame is now the first player frame
		NumberOfFramesActive=1
		repeat 
			framecount=framecount+1
			health=select(1, frame:GetChildren())
			local name=health.name:GetText()
			SetFrameColors(name)
			SetClassFrame(name)
			if framecount==1 then
				_G["PlayerFrame" .. name]:SetPoint("TOP",_G["PlayerFrame" .. name]:GetParent() , "TOP")
			elseif ((framecount-1)-5*math.floor((framecount-1)/5))==0 then --6th, 11, 16, etc frame
				_G["PlayerFrame" .. name]:SetPoint("TOP",_G["PlayerFrame" .. name]:GetParent() , "BOTTOM", 0, -SpacerSize*CurrentFrameHeight)
			else	
				_G["PlayerFrame" .. name]:SetPoint("TOP",_G["PlayerFrame" .. name]:GetParent() , "BOTTOM")
			end
			if PlayerIsTargeted[name] then
				local num=PlayerIsTargeted[name]
				if num>15 then num=15 end
				local r, g, b
				r, g, b=unpack(TargetColors[num])
				if TargetCountEnable then
					_G["PlayerFrame" .. name .. "Counter"]:Show()
					_G["PlayerFrame" .. name .. "Counter"].number:SetText(PlayerIsTargeted[name])
					_G["PlayerFrame" .. name .. "Counter"].number:SetTextColor(r,g,b)
				else
					_G["PlayerFrame" .. name .. "Counter"]:Hide() 
				end
			else
				_G["PlayerFrame" .. name .. "Counter"]:Hide() 
			end
			if select(ChildrenFrames+1, frame:GetChildren()) then 
				frame=select(ChildrenFrames+1, frame:GetChildren()) 
				NumberOfFramesActive=NumberOfFramesActive+1
			else
				frame=nil
			end
			--if BGPlayers then
			--	if BGPlayers[name]==nil then 
				--	RemoveFrame(name)
				--	print("REmoving", name, "because they left the bg.")
			--	end
			--end
		until not frame
	end
	--local executetime=debugprofilestop()*1000
	--if executetime>LagThreshold and DB4 then 
	--	print("Took", executetime, "uS to execute RefreshFrames")
	--end
end
