function CreateSpellTable()
	if SpellDatabase==nil then SpellDatabase={} end
--DRUID SPELLS
	SpellDatabase["Cat Form"]={"Druid", true}
	SpellDatabase["Moonkin Form"]={"Druid", true}
	SpellDatabase["Bear Form"]={"Druid", true}
	SpellDatabase["Lifebloom"]={"Druid", true}
--HUNTER SPELLS
	SpellDatabase["Arcane Shot"]={"Hunter", true}
	SpellDatabase["Steady Shot"]={"Hunter", true}
	SpellDatabase["Serpent Sting"]={"Hunter", true}
--PRIEST SPELLS
	SpellDatabase["Penance"]={"Priest", true}
	SpellDatabase["Shadow Word: Pain"]={"Priest", true}
	SpellDatabase["Renew"]={"Priest", true}
	SpellDatabase["Prayer of Healing"]={"Priest", true}
--WARLOCK SPELLS
	SpellDatabase["Curse of Agony"]={"Warlock", true}
	SpellDatabase["Drain Life"]={"Warlock", true}
	SpellDatabase["Fear"]={"Warlock", true}
	SpellDatabase["Corruption"]={"Warlock", true}
	SpellDatabase["Shadowfury"]={"Warlock", true}
--MAGE SPELLS
	SpellDatabase["Scorch"]={"Mage", true}
	SpellDatabase["Blink"]={"Mage", true}
	SpellDatabase["Frostbolt"]={"Mage", true}
	SpellDatabase["Arcane Missiles"]={"Mage", true}
--MONK SPELLS
	SpellDatabase["Stagger"]={"Monk", true}
	SpellDatabase["Soothing Mists"]={"Monk", true}
	SpellDatabase["Paralysis"]={"Monk", true}
--ROGUE SPELLS
	SpellDatabase["Mutilate"]={"Rogue", true}
	SpellDatabase["Revealing Strike"]={"Rogue", true}
	SpellDatabase["Backstab"]={"Rogue", true}
	SpellDatabase["Eviscerate"]={"Rogue", true}
	SpellDatabase["Stealth"]={"Rogue", true}
	SpellDatabase["Evasion"]={"Rogue", true}
	SpellDatabase["Sap"]={"Rogue", true}
	SpellDatabase["Recuperate"]={"Rogue", true}
	SpellDatabase["Kick"]={"Rogue", true}
	SpellDatabase["Crippling Poison"]={"Rogue", true}
	SpellDatabase["Gouge"]={"Rogue", true}
	SpellDatabase["Burst of Speed"]={"Rogue", true}
	SpellDatabase["Cheap Shot"]={"Rogue", true}
	SpellDatabase["Garrote"]={"Rogue", true}
	SpellDatabase["Kidney Shot"]={"Rogue", true}
	SpellDatabase["Cloak of Shadows"]={"Rogue", true}
	SpellDatabase["Wound Poison"]={"Rogue", true}
	SpellDatabase["Vanish"]={"Rogue", true}
--SHAMAN SPELLS
	SpellDatabase["Flameshock"]={"Shaman", true}
	SpellDatabase["Lightning Bolt"]={"Shaman", true}
	SpellDatabase["Earth Shield"]={"Shaman", true}
--DEATH KNIGHT
	SpellDatabase["Death Strike"]={"Death Knight", true}
	SpellDatabase["Frost Strike"]={"Death Knight", true}
	SpellDatabase["Scourge Strike"]={"Death Knight", true}
--WARRIOR
	SpellDatabase["Mortal Strike"]={"Warrior", true}
	SpellDatabase["Wild Strike"]={"Warrior", true}
	SpellDatabase["Shield Slam"]={"Warrior", true}
--PALADIN
	SpellDatabase["Holy Shock"]={"Paladin", true}
	SpellDatabase["Crusader Strike"]={"Paladin", true}
end

function CreateSpecWeights()
	if SpecWeights==nil then SpecWeights={} end
	
	SpecWeights["Warrior"]=13
	SpecWeights["Arms"]=11
	SpecWeights["Fury"]=12
	SpecWeights["Protection"]=6
	
	SpecWeights["Death Knight"]=16
	SpecWeights["Blood"]=7
	SpecWeights["FrostDK"]=14
	SpecWeights["Unholy"]=15
	
	SpecWeights["Paladin"]=18
	SpecWeights["HolyP"]=1
	SpecWeights["ProtectionP"]=8
	SpecWeights["Retribution"]=17
	
	SpecWeights["Monk"]=20
	SpecWeights["Brewmaster"]=9
	SpecWeights["Mistweaver"]=2
	SpecWeights["Windwalker"]=19
	
	SpecWeights["Priest"]=23
	SpecWeights["Discipline"]=3
	SpecWeights["Holy"]=3.8
	SpecWeights["Shadow"]=22
	
	SpecWeights["Shaman"]=26
	SpecWeights["Elemental"]=24
	SpecWeights["Enhancement"]=25
	SpecWeights["RestorationS"]=4
	
	SpecWeights["Druid"]=29
	SpecWeights["Balance"]=27
	SpecWeights["Feral Combat"]=28
	SpecWeights["Guardian"]=10
	SpecWeights["Restoration"]=5
	
	SpecWeights["Rogue"]=33
	SpecWeights["Assassination"]=30
	SpecWeights["Combat"]=31
	SpecWeights["Subtlety"]=32
	
	SpecWeights["Mage"]=37
	SpecWeights["Arcane"]=34
	SpecWeights["Fire"]=35
	SpecWeights["Frost"]=36
	
	SpecWeights["Warlock"]=41
	SpecWeights["Affliction"]=38
	SpecWeights["Demonology"]=39
	SpecWeights["Destruction"]=40
	
	SpecWeights["Hunter"]=45
	SpecWeights["Beast Mastery"]=42
	SpecWeights["Marksmanship"]=43
	SpecWeights["Survival"]=44
end

function CreateClassTable()
	if ClassColors==nil then ClassColors={} end
	ClassColors["Hunter"] = {0.67,0.83,0.45}
	ClassColors["Warlock"] = {0.58,0.51,0.79}
	ClassColors["Priest"] = {1.0,1.0,1.0}
	ClassColors["Paladin"] = {0.96,0.55,0.73}
	ClassColors["Mage"] = {0.41,0.8,0.94}
	ClassColors["Rogue"] = {1.0,0.96,0.41}
	ClassColors["Druid"] = {1.0,0.49,0.04}
	ClassColors["Shaman"] = {0.0,0.44,0.87}
	ClassColors["Warrior"] = {0.78,0.61,0.43}
	ClassColors["Death Knight"] = {0.77,0.12 ,0.23}
	ClassColors["Monk"] = {0.0,1.00,0.59}
end


function CreateSpecTable()
	if SpecDatabase==nil then SpecDatabase={} end
--DRUID SPELLS
	SpecDatabase["Savage Roar"]={"Druid", "Feral Combat"}
	SpecDatabase["Rake"]={"Druid", "Feral Combat"}
	SpecDatabase["Tiger's Fury"]={"Druid", "Feral Combat"}
	SpecDatabase["Rip"]={"Druid", "Feral Combat"}
	SpecDatabase["Swipe"]={"Druid", "Feral Combat"}
	SpecDatabase["Predatory Swiftness"]={"Druid", "Feral Combat"}
	SpecDatabase["Leader of the Pack"]={"Druid", "Feral Combat"}
	SpecDatabase["Starsurge"]={"Druid", "Balance"}
	SpecDatabase["Starfire"]={"Druid", "Balance"}
	SpecDatabase["Moonkin Form"]={"Druid", "Balance"}
	SpecDatabase["Astral Communion"]={"Druid", "Balance"}
	SpecDatabase["Shooting Stars"]={"Druid", "Balance"}
	SpecDatabase["Solar Beam"]={"Druid", "Balance"}
	SpecDatabase["Starfall"]={"Druid", "Balance"}
	--SpecDatabase["Wild Mushroom"]={"Druid", "Balance"}
	SpecDatabase["Savage Defense"]={"Druid", "Guardian"}
	SpecDatabase["Maul"]={"Druid", "Guardian"}
	SpecDatabase["Tooth and Claw"]={"Druid", "Guardian"}
	SpecDatabase["Lacerate"]={"Druid", "Guardian"}
	SpecDatabase["Ursa Major"]={"Druid", "Guardian"}
	SpecDatabase["Lifebloom"]={"Druid", "Restoration"}
	SpecDatabase["Swiftmend"]={"Druid", "Restoration"}
	SpecDatabase["Regrowth"]={"Druid", "Restoration"}
	SpecDatabase["Nature's Cure"]={"Druid", "Restoration"}
	SpecDatabase["Living Seed"]={"Druid", "Restoration"}
	SpecDatabase["Nature's Swiftness"]={"Druid", "Restoration"}
	SpecDatabase["Ironbark"]={"Druid", "Restoration"}
	SpecDatabase["Wild Growth"]={"Druid", "Restoration"}
--HUNTER SPELLS
	SpecDatabase["Bestial Wrath"]={"Hunter", "Beast Mastery"}
	SpecDatabase["Kill Command"]={"Hunter", "Beast Mastery"}
	SpecDatabase["Go for the Throat"]={"Hunter", "Beast Mastery"}
	SpecDatabase["Focus Fire"]={"Hunter", "Beast Mastery"}
	SpecDatabase["Cobra Strikes"]={"Hunter", "Beast Mastery"}
	SpecDatabase["Chimaera Shot"]={"Hunter", "Marksmanship"}
	SpecDatabase["Aimed Shot"]={"Hunter", "Marksmanship"}
	SpecDatabase["Chimaera Shot"]={"Hunter", "Marksmanship"}
	SpecDatabase["Bombardment"]={"Hunter", "Marksmanship"}
	SpecDatabase["Rapid Fire"]={"Hunter", "Marksmanship"}
	SpecDatabase["Explosive Shot"]={"Hunter", "Survival"}
	SpecDatabase["Black Arrow"]={"Hunter", "Survival"}
	SpecDatabase["Entrapment"]={"Hunter", "Survival"}
	SpecDatabase["Serpent Sting"]={"Hunter", "Survival"}
--PRIEST SPELLS
	SpecDatabase["Penance"]={"Priest", "Discipline"}
	SpecDatabase["Borrowed Time"]={"Priest", "Discipline"}
	SpecDatabase["Holy Nova"]={"Priest", "Discipline"}
	SpecDatabase["Divine Aegis"]={"Priest", "Discipline"}
	SpecDatabase["Atonement"]={"Priest", "Discipline"}
	SpecDatabase["Archangel"]={"Priest", "Discipline"}
	SpecDatabase["Pain Suppression"]={"Priest", "Discipline"}
	SpecDatabase["Power Word: Barrier"]={"Priest", "Discipline"}
	SpecDatabase["Circle of Healing"]={"Priest", "Holy"}
	SpecDatabase["Holy Word: Chastise"]={"Priest", "Holy"}
	SpecDatabase["Renew"]={"Priest", "Holy"}
	SpecDatabase["Serendipity"]={"Priest", "Holy"}
	SpecDatabase["Lightwell"]={"Priest", "Holy"}
	SpecDatabase["Binding Heal"]={"Priest", "Holy"}
	SpecDatabase["Chakra: Chastise"]={"Priest", "Holy"}
	SpecDatabase["Chakra: Sanctuary"]={"Priest", "Holy"}
	SpecDatabase["Chakra: Serenity"]={"Priest", "Holy"}
	SpecDatabase["Mind Flay"]={"Priest", "Shadow"}
	SpecDatabase["Devouring Plague"]={"Priest", "Shadow"}
	SpecDatabase["Mind Blast"]={"Priest", "Shadow"}
	SpecDatabase["Shadow Orbs"]={"Priest", "Shadow"}
	SpecDatabase["Shadowform"]={"Priest", "Shadow"}
	SpecDatabase["Vampirit Touch"]={"Priest", "Shadow"}
	SpecDatabase["Shadowy Apparitions"]={"Priest", "Shadow"}
	SpecDatabase["Mind Spike"]={"Priest", "Shadow"}
	SpecDatabase["Dispersion"]={"Priest", "Shadow"}
	SpecDatabase["Psychic Horror"]={"Priest", "Shadow"}
	SpecDatabase["Vampiric Embrace"]={"Priest", "Shadow"}
--WARLOCK SPELLS
	SpecDatabase["Haunt"]={"Warlock", "Affliction"}
	SpecDatabase["Unstable Affliction"]={"Warlock", "Affliction"}
	SpecDatabase["Soulburn"]={"Warlock", "Affliction"}
	SpecDatabase["Seed of Corruption"]={"Warlock", "Affliction"}
	SpecDatabase["Drain Soul"]={"Warlock", "Affliction"}
	SpecDatabase["Agony"]={"Warlock", "Affliction"}
	SpecDatabase["Soul Swap"]={"Warlock", "Affliction"}
	SpecDatabase["Hand of Gul'dan"]={"Warlock", "Demonology"}
	SpecDatabase["Doom"]={"Warlock", "Demonology"}
	SpecDatabase["Metamorphosis"]={"Warlock", "Demonology"}
	SpecDatabase["Demonic Leap"]={"Warlock", "Demonology"}
	SpecDatabase["Soul Fire"]={"Warlock", "Demonology"}
	SpecDatabase["Hellfire"]={"Warlock", "Demonology"}
	SpecDatabase["Wild Imps"]={"Warlock", "Demonology"}
	SpecDatabase["Incinerate"]={"Warlock", "Destruction"}
	SpecDatabase["Chaos Bolt"]={"Warlock", "Destruction"}
	SpecDatabase["Conflagrate"]={"Warlock", "Destruction"}
	SpecDatabase["Immolate"]={"Warlock", "Destruction"}
	SpecDatabase["Ember Tap"]={"Warlock", "Destruction"}
	SpecDatabase["Rain of Fire"]={"Warlock", "Destruction"}
	SpecDatabase["Fire and Brimstone"]={"Warlock", "Destruction"}
--MAGE SPELLS
	SpecDatabase["Arcane Blast"]={"Mage", "Arcane"}
	SpecDatabase["Arcane Barrage"]={"Mage", "Arcane"}
	SpecDatabase["Arcane Explosion"]={"Mage", "Arcane"}
	SpecDatabase["Arcane Missiles"]={"Mage", "Arcane"}
	SpecDatabase["Slow"]={"Mage", "Arcane"}
	SpecDatabase["Mage Armor"]={"Mage", "Arcane"}
	SpecDatabase["Arcane Power"]={"Mage", "Arcane"}
	SpecDatabase["Fireball"]={"Mage", "Fire"}
	SpecDatabase["Pyroblast"]={"Mage", "Fire"}
	SpecDatabase["Fireball"]={"Mage", "Fire"}
	SpecDatabase["Scorch"]={"Mage", "Fire"}
	SpecDatabase["Inferno Blast"]={"Mage", "Fire"}
	SpecDatabase["Molten Armor"]={"Mage", "Fire"}
	SpecDatabase["Flamestrike"]={"Mage", "Fire"}
	SpecDatabase["Dragon's Breath"]={"Mage", "Fire"}
	SpecDatabase["Combustion"]={"Mage", "Fire"}
	SpecDatabase["Frostbolt"]={"Mage", "Frost"}
	SpecDatabase["Summon Water Elemental"]={"Mage", "Frost"}
	SpecDatabase["Ice Lance"]={"Mage", "Frost"}
	SpecDatabase["Fingers of Frost"]={"Mage", "Frost"}
	SpecDatabase["Icy Veins"]={"Mage", "Frost"}
	SpecDatabase["Blizzard"]={"Mage", "Frost"}
	SpecDatabase["Frost Armor"]={"Mage", "Frost"}
	SpecDatabase["Frozen Orb"]={"Mage", "Frost"}
	SpecDatabase["Deep Freeze"]={"Mage", "Frost"}
--MONK SPELLS
	SpecDatabase["Dizzying Haze"]={"Monk", "Brewmaster"}
	SpecDatabase["Stance of the Sturdy Ox"]={"Monk", "Brewmaster"}
	SpecDatabase["Keg Smash"]={"Monk", "Brewmaster"}
	SpecDatabase["Breath of Fire"]={"Monk", "Brewmaster"}
	SpecDatabase["Guard"]={"Monk", "Brewmaster"}
	SpecDatabase["Elusive Brew"]={"Monk", "Brewmaster"}
	SpecDatabase["Soothing Mist"]={"Monk", "Mistweaver"}
	SpecDatabase["Stance of the Spirited Crane"]={"Monk", "Mistweaver"}
	SpecDatabase["Stance of the Wise Serpent"]={"Monk", "Mistweaver"}
	SpecDatabase["Enveloping Mist"]={"Monk", "Mistweaver"}
	SpecDatabase["Renewing Mist"]={"Monk", "Mistweaver"}
	SpecDatabase["Life Cocoon"]={"Monk", "Mistweaver"}
	SpecDatabase["Mana Tea"]={"Monk", "Mistweaver"}
	SpecDatabase["Detonate Chi"]={"Monk", "Mistweaver"}
	SpecDatabase["Fists of Fury"]={"Monk", "Windwalker"}
	SpecDatabase["Flying Serpent Kick"]={"Monk", "Windwalker"}
	SpecDatabase["Fists of Fury"]={"Monk", "Windwalker"}
	SpecDatabase["Touch of Karma"]={"Monk", "Windwalker"}
	SpecDatabase["Energizing Brew"]={"Monk", "Windwalker"}
	SpecDatabase["Tigereye Brew"]={"Monk", "Windwalker"}
	SpecDatabase["Windflurry"]={"Monk", "Windwalker"}
--ROGUE SPELLS
	SpecDatabase["Mutilate"]={"Rogue", "Assassination"}
	SpecDatabase["Envenom"]={"Rogue", "Assassination"}
	SpecDatabase["Dispatch"]={"Rogue", "Assassination"}
	SpecDatabase["Venomous Wounds"]={"Rogue", "Assassination"}
	SpecDatabase["Vendetta"]={"Rogue", "Assassination"}
	SpecDatabase["Revealing Strike"]={"Rogue", "Combat"}
	SpecDatabase["Blade Flurry"]={"Rogue", "Combat"}
	SpecDatabase["Killing Spree"]={"Rogue", "Combat"}
	SpecDatabase["Bandit's Guile"]={"Rogue", "Combat"}
	SpecDatabase["Adrenaline Rush"]={"Rogue", "Combat"}
	SpecDatabase["Hemorrhage"]={"Rogue", "Subtlety"}
	SpecDatabase["Master of Subtlety"]={"Rogue", "Subtlety"}
	SpecDatabase["Backstab"]={"Rogue", "Subtlety"}
	SpecDatabase["Shadow Dance"]={"Rogue", "Subtlety"}
	SpecDatabase["Energetic Recovery"]={"Rogue", "Subtlety"}
--SHAMAN SPELLS
	--SpecDatabase["Lightning Bolt"]={"Shaman", "Elemental"}
	SpecDatabase["Earthquake"]={"Shaman", "Elemental"}
	SpecDatabase["Earth Shock"]={"Shaman", "Elemental"}
	SpecDatabase["Thunderstorm"]={"Shaman", "Elemental"}
	SpecDatabase["Lava Surge"]={"Shaman", "Elemental"}
	SpecDatabase["Maelstrom Weapon"]={"Shaman", "Enhancement"}
	SpecDatabase["Spirit Walk"]={"Shaman", "Enhancement"}
	SpecDatabase["Storm Strike"]={"Shaman", "Enhancement"}
	SpecDatabase["Spirit Walk"]={"Shaman", "Enhancement"}
	SpecDatabase["Flametongue"]={"Shaman", "Enhancement"}
	SpecDatabase["Earth Shield"]={"Shaman", "RestorationS"}
	SpecDatabase["Riptide"]={"Shaman", "RestorationS"}
	SpecDatabase["Spirit Link Totem"]={"Shaman", "RestorationS"}
	SpecDatabase["Purify Spirit"]={"Shaman", "RestorationS"}
	SpecDatabase["Water Shield"]={"Shaman", "RestorationS"}
	SpecDatabase["Resurgence"]={"Shaman", "RestorationS"}
	SpecDatabase["Chain Heal"]={"Shaman", "RestorationS"}
	SpecDatabase["Tidal Waves"]={"Shaman", "RestorationS"}
	SpecDatabase["Healing Wave"]={"Shaman", "RestorationS"}
--DEATH KNIGHT
	SpecDatabase["Bone Shield"]={"Death Knight", "Blood"}
	SpecDatabase["Vampiric Blood"]={"Death Knight", "Blood"}
	SpecDatabase["Rune Tap"]={"Death Knight", "Blood"}
	SpecDatabase["Power of the Grave"]={"Death Knight", "Blood"}
	SpecDatabase["Frost Strike"]={"Death Knight", "FrostDK"}
	SpecDatabase["Obliterate"]={"Death Knight", "FrostDK"}
	SpecDatabase["Howling Blast"]={"Death Knight", "FrostDK"}
	SpecDatabase["Pillar of Frost"]={"Death Knight", "FrostDK"}
	SpecDatabase["Killing Machine"]={"Death Knight", "FrostDK"}
	SpecDatabase["Scourge Strike"]={"Death Knight", "Unholy"}
	SpecDatabase["Festering Strike"]={"Death Knight", "Unholy"}
	SpecDatabase["Dark Transformation"]={"Death Knight", "Unholy"}
	SpecDatabase["Summon Gargoyle"]={"Death Knight", "Unholy"}
	SpecDatabase["Shadow Infusion"]={"Death Knight", "Unholy"}
--WARRIOR
	SpecDatabase["Mortal Strike"]={"Warrior", "Arms"}
	SpecDatabase["Rend"]={"Warrior", "Arms"}
	SpecDatabase["Sweeping Strikes"]={"Warrior", "Arms"}
	SpecDatabase["Mortal Strike"]={"Warrior", "Arms"}
	SpecDatabase["Colossus Smash"]={"Warrior", "Arms"}
	SpecDatabase["Wild Strike"]={"Warrior", "Fury"}
	SpecDatabase["Bloodthirst"]={"Warrior", "Fury"}
	SpecDatabase["Wild Strike"]={"Warrior", "Fury"}
	SpecDatabase["Piercing Howl"]={"Warrior", "Fury"}
	SpecDatabase["Raging Blow"]={"Warrior", "Fury"}
	SpecDatabase["Shield Slam"]={"Warrior", "Protection"}
	SpecDatabase["Shield Block"]={"Warrior", "Protection"}
	SpecDatabase["Devastate"]={"Warrior", "Protection"}
	SpecDatabase["Revenge"]={"Warrior", "Protection"}
	SpecDatabase["Demoralizing Shout"]={"Warrior", "Protection"}
--PALADIN
	SpecDatabase["Holy Shock"]={"Paladin", "HolyP"}
	SpecDatabase["Holy Radiance"]={"Paladin", "HolyP"}
	SpecDatabase["Holy Light"]={"Paladin", "HolyP"}
	SpecDatabase["Beacon of Light"]={"Paladin", "HolyP"}
	SpecDatabase["Divine Light"]={"Paladin", "HolyP"}
	SpecDatabase["Light of Dawn"]={"Paladin", "HolyP"}
	SpecDatabase["Avenger's Shield"]={"Paladin", "ProtectionP"}
	SpecDatabase["Judgements of the Wise"]={"Paladin", "ProtectionP"}
	SpecDatabase["Exorcism"]={"Paladin", "Retribution"}
	SpecDatabase["Templar's Verdict"]={"Paladin", "Retribution"}
	SpecDatabase["Seal of Justice"]={"Paladin", "Retribution"}
	SpecDatabase["Judgements of the Bold"]={"Paladin", "Retribution"}
end

local Blue={122/255, 122/255, 255/255}
local Green={122/255, 255/255, 122/255}

function CreateNameColors()
	if NameColors==nil then NameColors={} end
	NameColors["Restoration"]=Green
	NameColors["Guardian"]=Blue
	NameColors["Discipline"]=Green
	NameColors["Holy"]=Green
	NameColors["Brewmaster"]=Blue
	NameColors["Mistweaver"]=Green
	NameColors["RestorationS"]=Green
	NameColors["Blood"]=Blue
	NameColors["Protection"]=Blue
	NameColors["HolyP"]=Green
	NameColors["ProtectionP"]=Blue
end

function CreateTargetColors()
	if TargetColors==nil then TargetColors={} end
	TargetColors[1]={0,1,0}
	TargetColors[2]={111/255, 1, 0}
	TargetColors[3]={229/255, 1, 0}
	TargetColors[4]={1, 221/255, 0}
	TargetColors[5]={1, 166/255, 0}
	TargetColors[6]={1, 115/255, 0}
	TargetColors[7]={1, 0, 0}
	TargetColors[8]={1, 0, 55/255}
	TargetColors[9]={1, 0, 149/255}
	TargetColors[10]={144/255, 0, 1}
	TargetColors[11]={100/255, 0, 1}
	TargetColors[12]={90/255, 0, 1}
	TargetColors[13]={80/255, 0, 1}
	TargetColors[14]={70/255, 0, 1}
	TargetColors[15]={60/255, 0, 1}
end

function HandleName(ID)
	local name, realm=UnitName(ID)
	if name==nil then
		name=""
	elseif realm and realm~="" then
		name=name.."-"..realm
	end
	if string.find(name, "Nachta") then name="Nach'ta" end
	if not ShowServerWork and string.find(name, "-") then 
		local stop=strfind(name, "-")-1
		name=string.sub(name, 1, stop)
	end
	--print("handling", ID, "'s name, which is", name)
	if name then 
		if ID=="target" and PlayerNamesDisplayed[name] then
			PlayerTargetFrame:Show()
			PlayerTargetFrame:SetPoint("CENTER", _G["PlayerFrame" .. name], "CENTER")
			PlayerTargetFrame:SetFrameLevel(100)
		else
			PlayerTargetFrame:Hide()
		end
		if string.len(name)>StringMaxLength then name=string.sub(name, 1, StringMaxLength) end
		PlayerLastActive[name]=GetTime()
		PlayerHealth[name]=UnitHealth(ID)
		PlayerMaxHealth[name]=UnitHealthMax(ID)
		local playerspec
		if ClassByName[name] then 
			playerspec=(ClassByName[name])[3]
		else
			playerspec=nil
		end
		ClassByName[name]={select(1, UnitClass(ID)), true, playerspec}
		SetFrameColors(name)
		SetClassFrame(name)
		SetHealthBars()
		if PlayerNamesDisplayed[name]==nil then
			if UnitIsEnemy(ID, "player") and UnitIsPlayer(ID) then
				--print("adding frame for", name, "by HandleName function.")
				AddFrame(name)
				SortFrames()
				SetClassFrame(name)
			end
		end
		if PlayerIsTargeted[name] then 
			PlayerIsTargeted[name]=PlayerIsTargeted[name]+1 
		else 
			PlayerIsTargeted[name]=1 
		end
		if not PlayerGuilds[name] then PlayerGuilds[name]=select(1, GetGuildInfo(ID)) end
	end
end






